#!/usr/bin/perl


open CREA_RULES, ">file_import/creare_regole.csv";
open ADD_DEST_OBJ, ">file_import/add_obj_destinations.csv";
open ADD_SRC_OBJ, ">file_import/add_obj_sources.csv";
open ADD_SERVICES, ">file_import/add_services.csv";
print CREA_RULES "######## USAGE #### mgmt_cli -u admin -p 'password' add access-rule --batch creare_regole.csv #######\n";
print CREA_RULES "layer,position,name,source,destination,vpn,service,time,action,track,install-on\n";
print ADD_DEST_OBJ "######## USAGE #### mgmt_cli -u admin -p 'password' set access-rule --batch add_obj_destinations.csv #######\n";
print ADD_DEST_OBJ "layer,position,name,destination.add\n";
print ADD_SRC_OBJ "######## USAGE #### mgmt_cli -u admin -p 'password' set access-rule --batch add_obj_sources.csv #######\n";
print ADD_SRC_OBJ "layer,position,name,source.add\n";
print ADD_SERVICES "######## USAGE #### mgmt_cli -u admin -p 'password' set access-rule --batch add_services.csv #######\n";
print ADD_SERVICES "layer,position,name,service.add\n";
$file_rules = "$ARGV[0]";

open FILE, "$file_rules";
@array_rules = <FILE>;
foreach $riga (@array_rules)
{
chomp $riga;
($num,$type,$name,$src,$dst,$vpn,$srv,$content,$time,$action,$track,$install_on,$comment) =  split /,/ , $riga;
@array_src = split /;/, $src;
@array_dst = split /;/, $dst;
@array_srv = split /;/, $srv;
if (!$name) {$name = "rule" . $num}
$name =~ tr/ /_/;
if (!$time) {$time = "any"}
print CREA_RULES "prova,$num,$name,$array_src[0],$array_dst[0],$vpn,$array_srv[0],$time,$action,$track,$install_on,\n";

	if ($riga =~ /\;/)
	 	{	
			if ($src =~ /\;/)
			{
			@split_src = split /;/ , $src;
			@print_from_2_element_src = @split_src[1 .. $#split_src];
			foreach $splitted_src (@print_from_2_element_src)
				{
					print ADD_SRC_OBJ "firewall_test,$num,$name,$splitted_src\n";
				}

			}
			 if ($dst =~ /\;/)
                        {
                        @split_dst = split /;/ , $dst;
			@print_from_2_element_dst = @split_dst[1 .. $#split_dst];
                        foreach $splitted_dst (@print_from_2_element_dst)
                                {
                                        print ADD_DEST_OBJ "firewall_test,$num,$name,$splitted_dst\n";
                                }

                        }

			if ($srv =~ /\;/)
                        {
                        @split_srv = split /;/ , $srv;
			@print_from_2_element_srv = @split_srv[1 .. $#split_srv];
                        foreach $splitted_srv (@print_from_2_element_srv)
                                {
                                        print ADD_SERVICES "firewall_test,$num,$name,$splitted_srv\n";
                                }

                        }
	
		#print "$src ----- $dst\n";
		}
	
}
